(***************************************************************)
(* Coq code for PCAP                                           *)
(*                                                             *)
(* Tactics                                                     *)
(*                                                             *)
(*                                                             *)
(***************************************************************)

(* $Id: deptac.v,v 1.2 2006/07/11 14:00:53 ssg05 Exp $ *)

Require Import Eqdep.

Tactic Notation "deprewrite" hyp (H) "in" hyp (H2) :=
  match type of H with
    | existT ?sch ?L ?t1 = existT _ _ ?t2 =>
      rewrite (inj_pairT2 _ sch L t1 t2 H) in H2
  end.

Tactic Notation "deprewrite" "<-" hyp (H) "in" hyp (H2) :=
  match type of H with
    | existT ?sch ?L ?t1 = existT _ _ ?t2 =>
      rewrite <- (inj_pairT2 _ sch L t1 t2 H) in H2
  end.

Tactic Notation "deprewrite" hyp (H) :=  
  match type of H with
    | existT ?sch ?L ?t1 = existT _ _ ?t2 =>
      rewrite (inj_pairT2 _ sch L t1 t2 H)
  end.

Tactic Notation "deprewrite" "<-" hyp (H) :=  
  match type of H with
    | existT ?sch ?L ?t1 = existT _ _ ?t2 =>
      rewrite <- (inj_pairT2 _ sch L t1 t2 H)
  end.

Tactic Notation "gen_depeq" hyp (H) :=  
  match type of H with
    | existT ?sch ?L ?t1 = existT _ _ ?t2 =>
      generalize (inj_pairT2 _ sch L t1 t2 H)
  end.

Tactic Notation "gen_depdepeq" hyp (H) :=
  let H2 := fresh "H" in
  gen_depeq H; intro H2; gen_depeq H2; clear H2.