(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* optionT                                                     *)
(*                                                             *)
(***************************************************************)

(* $Id: optionT.v,v 1.4 2006/07/15 02:56:42 ssg05 Exp $ *)

Inductive optionT (A : Type) : Type :=
  | SomeT : A -> optionT A
  | NoneT : optionT A.

Implicit Arguments SomeT [A].
Implicit Arguments NoneT [A].

Notation opt_predT :=
  (fun opt:optionT _ => 
    fun f =>
      match opt with
	| SomeT t => f t
	| NoneT => False
      end).

Notation optpT :=
  (fun f => fun opt:optionT _ => 
    match opt with
      | SomeT t => f t
      | NoneT => False
    end).

Notation optgT :=
  (fun f => fun opt:optionT _ =>
    fun t' =>
      match opt with
        | SomeT t => f t t'
        | NoneT => False
      end).

Notation opt_predT2 :=
  (fun opt:optionT _ => 
    fun opt':optionT _ => 
      fun f =>
	match opt, opt' with
	  | SomeT t, SomeT t' => f t t'
	  | _, _ => False
	end).
