(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* Tiny Machine                                                *)
(*                                                             *)
(*                                                             *)
(***************************************************************)

(* $Id: label.v,v 1.4 2006/07/15 02:56:42 ssg05 Exp $ *)

Require Import Coq.Arith.Compare_dec.
Require Import Omega.
Require Import natutil.

Definition label := nat.

Implicit Types l f : label.

Definition A := label.

Definition lt a b := (a < b).
Definition gt a b := lt b a.

Definition compare_dec := lt_eq_lt_dec.

Lemma eq_not_lt : forall a b, a = b -> a < b -> False.
Proof.
  intros; omega.
Qed.

Lemma lt_not_eq : forall a b, a < b -> a = b -> False.
Proof.
  intros; omega.
Qed.

Lemma lt_not_gt : forall a b, a < b -> b < a -> False.
Proof.
  intros; omega.
Qed.

Lemma lt_trans : forall a b c, a < b -> b < c -> a < c.
Proof.
  intros; omega.
Qed.

Definition eq_dec := nat_eq_dec.